SystemOrganization addCategory: #ConfigurationOfGrandMa!

Object subclass: #ConfigurationOfGrandMa
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfGrandMa'!

!ConfigurationOfGrandMa class methodsFor: 'development support' stamp: 'FrancoisStephany 4/17/2012 15:40'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfGrandMa class methodsFor: 'private' stamp: 'FrancoisStephany 4/17/2012 15:40'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfGrandMa class methodsFor: 'private' stamp: 'FrancoisStephany 4/17/2012 15:40'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfGrandMa class methodsFor: 'private' stamp: 'FrancoisStephany 4/17/2012 15:40'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfGrandMa class methodsFor: 'metacello tool support' stamp: 'FrancoisStephany 4/17/2012 15:40'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfGrandMa class methodsFor: 'loading' stamp: 'FrancoisStephany 4/17/2012 15:40'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfGrandMa class methodsFor: 'loading' stamp: 'FrancoisStephany 4/17/2012 15:40'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfGrandMa class methodsFor: 'loading' stamp: 'FrancoisStephany 4/17/2012 15:40'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfGrandMa class methodsFor: 'accessing' stamp: 'FrancoisStephany 4/17/2012 15:40'!
project

	^self new project! !

!ConfigurationOfGrandMa class methodsFor: 'development support' stamp: 'FrancoisStephany 4/17/2012 15:40'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfGrandMa methodsFor: 'baselines' stamp: 'FrancoisStephany 4/17/2012 16:45'!
baseline100: spec 
	<version: '1.0-baseline'>
	spec for: #common do: [
		spec blessing: #baseline.
		spec project: 'OSProcess' with: [ 
			spec
				className: 'ConfigurationOfOSProcess';
				versionString: '4.4.5';
				file: 'ConfigurationOfOSProcess';
				repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		
		spec 
			repository: 'http://www.squeaksource.com/CommandShell';
			package: 'CommandShell-Base' with: 'CommandShell-Base-dtl.18';
			package: 'CommandShell-Commands' with: 'CommandShell-Commands-dtl.9';
			package: 'CommandShell-Piping' with: 'CommandShell-Piping-dtl.8'.
		
		spec repository: 'http://ss3.gemstone.com/ss/grandma'.
		spec 
			package: 'GrandMa-Core';
			package: 'GrandMa-Worker' with: [
				spec requires: #('OSProcess' 'CommandShell' 'CommandShell-Base' 'CommandShell-Commands' 'CommandShell-Piping')];
			package: 'GrandMa-Tests' with: [ spec requires: #('GrandMa-Core' 'GrandMa-Worker') ].
		spec
			group: 'default' with: #('Tests');
			group: 'Core' with: #('GrandMa-Core');
			group: 'Worker' with: #('GrandMa-Worker');
			group: 'Tests' with: #('Gofer-Tests'). ].
! !

!ConfigurationOfGrandMa methodsFor: 'accessing' stamp: 'FrancoisStephany 4/17/2012 15:40'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfGrandMa methodsFor: 'versions' stamp: 'FrancoisStephany 4/17/2012 16:32'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>
	spec for: #common do: [
		spec blessing: #development..
		spec
			package: 'GrandMa-Core' with: 'GrandMa-Core-FrancoisStephany.4';
			package: 'GrandMa-Worker' with: 'GrandMa-Worker-FrancoisStephany.3';
			package: 'GrandMa-Tests' with: 'GrandMa-Tests--FrancoisStephany.4'.
	]! !
